You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

916 lines
21 KiB

  1. #!/bin/bash
  2. # TODO: use tput
  3. # If not running interactively, don't do anything
  4. [[ $- != *i* ]] && return
  5. ##########################################
  6. null(){
  7. "$@" >/dev/null 2>&1
  8. }
  9. __try_exec(){
  10. type $1 >/dev/null 2>&1 && "$@"
  11. }
  12. ##########################
  13. # system type
  14. alias ismsys=false
  15. alias iscygwin=false
  16. alias iswindows=false
  17. alias isdarwin=false
  18. alias islinux=false
  19. alias with_coreutils=false # for mac
  20. case `uname` in
  21. (MINGW*) alias ismsys=true ;;
  22. (CYGWIN*) alias iscygwin=true ;;
  23. (Darwin*) alias isdarwin=true ;;
  24. (Linux*) alias islinux=true ;;
  25. esac
  26. null ls --version && alias with_coreutils=true
  27. ( ismsys || iscygwin ) && alias iswindows=true
  28. alias inbash=false
  29. alias inzsh=false
  30. if test -n "$BASH_VERSION"
  31. then
  32. alias inbash=true
  33. elif test -n "$ZSH_VERSION"
  34. then
  35. alias inzsh=true
  36. fi
  37. #################################
  38. __match(){
  39. # __match str1 str2
  40. # return 0 if str2 is found in str1
  41. expr "$1" : ".*$2.*" >/dev/null
  42. }
  43. if ! __match "$PATH" "$HOME/.local/bin"
  44. then
  45. PATH="${PATH}:${HOME}/.local/bin:$HOME/.local/lib/gems/bin"
  46. fi
  47. if ismsys && ! __match "$PATH" /c/mingw/bin
  48. then
  49. PATH="$PATH:/c/mingw/bin:/c/mingw/msys/1.0/bin"
  50. fi
  51. # # it is not so good
  52. # # http://archive.linux.or.jp/JF/JFdocs/Program-Library-HOWTO/shared-libraries.html
  53. # # http://superuser.com/questions/324613/installing-a-library-locally-in-home-directory-but-program-doesnt-recognize-it
  54. # without this ENV i cannot run tmux. another way is to use --disable-shared
  55. # when building tmux
  56. if ! __match "$LD_LIBRARY_PATH" "$HOME/.local/lib"
  57. then
  58. export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HOME/.local/lib"
  59. fi
  60. ##################################
  61. export LANG=ja_JP.UTF-8
  62. export LC_MESSAGES=C
  63. export TERMCAP="${TERMCAP}:vb="
  64. ismsys && export HOSTNAME
  65. export ENV=~/.shrc
  66. if false iswindows
  67. then
  68. export PAGER='tr -d \\r | less'
  69. else
  70. export PAGER="less"
  71. fi
  72. export LESS="-iRMX"
  73. _src_hilite_lp_path="`which src-hilite-lesspipe.sh 2>/dev/null`"
  74. if test -n "$_src_hilite_lp_path"
  75. then
  76. export LESSOPEN="| $_src_hilite_lp_path %s"
  77. fi
  78. if null type vim
  79. then
  80. export EDITOR=vim
  81. else
  82. export EDITOR=vi
  83. fi
  84. # export CDPATH=".:~"
  85. export VISUAL="$EDITOR"
  86. export GIT_PAGER="less -F"
  87. export GIT_EDITOR="$EDITOR"
  88. export GIT_MERGE_AUTOEDIT=no
  89. if test -n "$TMUX" && \
  90. echo $TERM | grep screen >/dev/null 2>&1 && \
  91. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  92. then
  93. TERM=screen-256color
  94. fi
  95. if test -z "$TMP"
  96. then
  97. if test -n "$TMPDIR"
  98. then
  99. export TMP=$TMPDIR
  100. elif test -n "$TEMP"
  101. then
  102. export TMP="$TEMP"
  103. else
  104. export TMP=/tmp
  105. fi
  106. fi
  107. __match "$TMP" "${USER}-tmp" >/dev/null || export TMP="${TMP}/${USER}-tmp"
  108. export TEMP="$TMP"
  109. mkdir -p "$TMP"
  110. ! iswindows && null type stty && {
  111. stty stop undef # unbind C-s to stop displaying output
  112. # stty erase '^h'
  113. }
  114. if iswindows; then
  115. export USER=$USERNAME
  116. fi
  117. _tmux_prefs(){
  118. null type tmux || return 1
  119. tmux set -g mode-keys vi
  120. }
  121. if test -d ~/dbx
  122. then
  123. export CHIT_PATH="$HOME/dbx/.chit"
  124. fi
  125. #######################
  126. iswindows && alias tty="echo cmd.exe"
  127. type fortune >/dev/null 2>&1 && {
  128. fortune
  129. echo
  130. fortune -o
  131. echo
  132. }
  133. uname -a
  134. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  135. running $BASH $BASH_VERSION
  136. if test -n "$TMUX"
  137. then
  138. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  139. 2>/dev/null
  140. echo
  141. fi
  142. ###################################
  143. # some aliases and functions
  144. ( ! with_coreutils && isdarwin ) || test "$TERM" = dumb || \
  145. _coloroption=" --color=auto"
  146. ( ! with_coreutils && isdarwin ) || iswindows || \
  147. _timeoption=" --time-style=long-iso"
  148. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  149. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  150. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  151. _timeformat_num="%Y%m%d%H%M%S"
  152. alias datenum="date +$_timeformat_num"
  153. alias ls="ls -hCF${_coloroption}${_timeoption}"
  154. if ! with_coreutils
  155. then
  156. export LSCOLORS=gxfxcxdxbxegedabagacad
  157. alias ls="ls -G"
  158. fi
  159. # export GREP_OPTIONS=""
  160. alias gr="grep -n --color=always"
  161. iswindows && alias grep="grep -n"
  162. # alias ll="ls -l"
  163. # alias la="ls -A"
  164. # alias lla="ls -Al"
  165. alias less="less -F"
  166. null type emacs && alias em="emacs -nw"
  167. null type vim && alias vi=vim
  168. alias pstree="LANG=C pstree"
  169. alias cp="cp -v"
  170. alias mv="mv -v"
  171. alias rm="rm -v"
  172. alias psaux="ps auxww"
  173. alias q=exit
  174. null type e3em && alias e3=e3em
  175. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  176. alias po=popd
  177. alias pu=pushd
  178. null type sudo && alias sudo="sudo " # use aliases through sudo
  179. null type sudoedit && alias sudoe="sudoedit"
  180. null type halt && alias halt="sudo halt"
  181. null type reboot && alias reboot="sudo reboot"
  182. null type dbus-send && {
  183. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  184. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  185. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  186. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  187. }
  188. alias rand="echo \$RANDOM"
  189. null type file-roller && alias xunp="file-roller -h"
  190. null type paco && alias pc="sudo \paco -D"
  191. alias pycalc="python -i -c 'from math import *' "
  192. null type python3 && alias py3=python3
  193. null type python2 && alias py2=python2
  194. alias _reloadrc="exec \"$SHELL\""
  195. # alias mytime="date +%Y%m%d-%H%M%S"
  196. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  197. # type trash >/dev/null 2>&1 && alias rm=trash
  198. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  199. null type xmms2 && alias xm="xmms2"
  200. #export PLAYER="mpg123 -C -v --title"
  201. null type screen && alias screen="screen -e^z^z"
  202. #alias zcd="cd \`zenity --file-selection --directory\`"
  203. null type gtags && alias gtags="gtags --verbose"
  204. null type htags && alias htags="htags --xhtml --symbol --line-number \
  205. --frame --alphabet --verbose"
  206. null type aunpack && alias au=aunpack
  207. null type lv && alias lv="lv|less"
  208. null type rsync && alias rs="rsync --progress --itemize-changes --compress"
  209. isdarwin && alias updatedb="LC_ALL=C updatedb"
  210. # do not use locate installed by macports
  211. isdarwin && test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  212. # pad
  213. alias pad=notepad
  214. null type gedit && alias pad=gedit
  215. null type leafpad && alias pad=leafpad
  216. isdarwin && alias pad="open -e"
  217. null type wicd-curses && alias wic=wicd-curses
  218. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  219. #alias wicn="wicd-cli -y -c -n"
  220. wicn(){
  221. if test $# -eq 0
  222. then
  223. local num
  224. wicd-cli -y -l | head
  225. echo -n "input num: "
  226. read num
  227. test -n "$num" && wicd-cli -y -c -n $num
  228. else
  229. wicd-cli -y -c -n $1
  230. fi
  231. }
  232. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  233. /usr/share/vim/vim73/macros/less.sh \
  234. /usr/share/vim/vim72/macros/less.sh
  235. do
  236. test -f $f && alias vl=$f && break
  237. done
  238. null type yaourt && alias yt=yaourt
  239. null type cower && alias cower="cower --color=auto"
  240. null type pacmatic && {
  241. alias pacman="pacmatic"
  242. export PACMAN="pacmatic"
  243. }
  244. _pacman_update_mirrorlist_with_reflector(){
  245. ml=/etc/pacman.d/mirrorlist
  246. cmd="$(expr "$(grep -m 1 reflector $ml)" : '# With: *\(.*\)')"
  247. if test -z "$cmd"
  248. then
  249. cmd="reflector --verbose -l 5 --sort rate --save $ml"
  250. fi
  251. echo "Running $cmd ..." 1>&2
  252. sudo $cmd
  253. }
  254. null type reflector && test -f /etc/pacman.d/mirrorlist && \
  255. alias reflect_mirrorlist=_pacman_update_mirrorlist_with_reflector
  256. null type apt-get && {
  257. alias aupgrade="sudo apt-get autoremove --yes && \
  258. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  259. alias aptin="apt-get install"
  260. alias aptsearch="apt-cache search"
  261. alias aptshow="apt-cache show"
  262. }
  263. null type port && {
  264. alias port="port -v"
  265. alias pupgrade="sudo port -v selfupdate && \
  266. { sudo port -v upgrade outdated; }"
  267. }
  268. if iscygwin; then
  269. null type windate || \
  270. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  271. # alias cygsu="cygstart /cygwinsetup.exe"
  272. # alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  273. fi
  274. g(){
  275. if test $# -eq 0 && null type git-info
  276. then
  277. git info
  278. else
  279. git "$@"
  280. fi
  281. }
  282. if null type _git && inbash
  283. then
  284. # enable programmable completion for g
  285. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  286. || complete -o default -o nospace -F _git g
  287. fi
  288. git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  289. null type gitmemo && alias m=gitmemo
  290. null type gitmemo && alias m=gitmemo
  291. alias setup.py="sudo python3 setup.py install --record files.txt"
  292. ssh(){
  293. __my_set_screen_title ssh
  294. command ssh "$@"
  295. }
  296. clk(){
  297. local tformat="%Y/%m/%d %H:%M:%S %z"
  298. cal
  299. REPLY=
  300. printf "\\r`date "+${tformat}"`"
  301. read -t 1
  302. while test $? -ne 0
  303. do
  304. printf "\\r`date "+${tformat}"`"
  305. read -t 1
  306. done
  307. }
  308. s(){
  309. if git rev-parse --git-dir >/dev/null 2>&1
  310. then
  311. echo ">> git grep -n $@" 1>&2
  312. git grep -n "$@"
  313. elif which ag >/dev/null 2>&1
  314. then
  315. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  316. ag --pager="$PAGER" "$@"
  317. elif which ack >/dev/null 2>&1
  318. then
  319. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  320. ack --pager="$PAGER" "$@"
  321. else
  322. echo \
  323. ">> grep -nH --color=always" \
  324. "--exclude=\'.svn/\*\' --exclude=\'.git/\*\'" \
  325. "$@" "-r ." 1>&2
  326. if test $# -eq 0
  327. then
  328. echo "No search word given." 1>&2
  329. return 1
  330. fi
  331. grep -nH --color=always --exclude='.svn/*' --exclude='.git/*' "$@" -r . \
  332. | $PAGER
  333. fi
  334. }
  335. man(){
  336. env \
  337. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  338. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  339. LESS_TERMCAP_me=$(printf "\e[0m") \
  340. LESS_TERMCAP_se=$(printf "\e[0m") \
  341. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  342. LESS_TERMCAP_ue=$(printf "\e[0m") \
  343. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  344. man "$@"
  345. }
  346. scr(){
  347. test -n "$1" && pf="${1}-"
  348. local _tformat="%Y%m%d-%H%M%S%z"
  349. local _file="${HOME}/${pf}`date +${_tformat}`.script"
  350. SCRIPT=${_file} script ${_file} "$@"
  351. }
  352. netwait(){
  353. while ! ping -c 1 -t 1 example.com
  354. do
  355. true
  356. done
  357. echo network works.
  358. }
  359. cd(){
  360. if test $# -eq 0
  361. then
  362. pushd ~/ >/dev/null
  363. elif test "$1" = -
  364. then
  365. local pwd="$PWD"
  366. command cd "$OLDPWD"
  367. pushd -n "$pwd" >/dev/null # stack last dir
  368. elif ! test -d "$1"
  369. then
  370. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  371. return 1
  372. else
  373. pushd "$1" >/dev/null
  374. fi
  375. __dirs_rm_dup "$PWD"
  376. echo "$PWD"
  377. }
  378. __dirs_rm_dup(){
  379. for d in "$@"
  380. do
  381. local next="$(__realpath --strip "$d")"
  382. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  383. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  384. do
  385. popd +$l -n >/dev/null
  386. done
  387. done
  388. }
  389. __realpath(){
  390. if type realpath >/dev/null 2>&1
  391. then
  392. command realpath "$@"
  393. else
  394. while ! test -d $1
  395. do
  396. shift
  397. done
  398. local d="$OLDPWD"
  399. command cd "$1"
  400. echo "$PWD"
  401. command cd "$d"
  402. fi
  403. }
  404. dh(){
  405. if test $# -eq 0
  406. then
  407. dirs -v -l
  408. else
  409. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  410. cd "$dir"
  411. fi
  412. }
  413. input(){
  414. local foo
  415. stty -echo
  416. read foo
  417. stty echo
  418. echo $foo
  419. }
  420. # tmux(){
  421. # if test $# -eq 0
  422. # then
  423. # (cd ~; command tmux start;)
  424. # if command tmux has -t main
  425. # then
  426. # command tmux attach -t main
  427. # else
  428. # (cd ~; command tmux new -s main;)
  429. # fi
  430. # else
  431. # command tmux "$@"
  432. # fi
  433. # }
  434. tx(){
  435. if test $# -eq 0
  436. then
  437. tmux ls
  438. echo "tx <session> to attach."
  439. elif tmux has -t "$1"
  440. then
  441. tmux attach -t "$1"
  442. else
  443. tmux new -s "$1"
  444. fi
  445. }
  446. mcrypt-stream(){
  447. test $# -eq 2 || return 1
  448. case $1 in
  449. en)
  450. mcrypt --key $2 | base64 ;;
  451. de)
  452. base64 -d | mcrypt -d --key $2 ;;
  453. esac
  454. }
  455. gpg-stream(){
  456. test $# -eq 2 || return 1
  457. case $1 in
  458. en)
  459. gpg --passphrase $2 -c --batch |base64 ;;
  460. de)
  461. base64 -d|gpg --passphrase $2 -d --batch ;;
  462. esac
  463. }
  464. dgpg(){
  465. if test "$1" = help || test -z "$2"
  466. then
  467. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  468. return
  469. fi
  470. local srcs="$2"
  471. local dsts="$3"
  472. test -z "$dsts" && dsts="${srcs}.out"
  473. local pw
  474. echo -n "dgpg pw: "
  475. read -s pw
  476. echo ""
  477. test -z "$pw" && return 1
  478. for f in *${srcs}
  479. do
  480. local d="$(basename "$f" "${srcs}")${dsts}"
  481. echo -n "Processing $f to $d..."
  482. if test -d "$f"
  483. then
  484. echo "`printf 'failed (%s is directory)' $f`"
  485. elif test -f "$d"
  486. then
  487. echo "`printf 'failed (%s is already exists)' $d`"
  488. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  489. then
  490. echo "done"
  491. else
  492. echo "failed"
  493. test -f "$d" && rm "$d"
  494. fi
  495. done
  496. }
  497. alias enst="gpg-stream en"
  498. alias dest="gpg-stream de"
  499. showinfo(){
  500. echo "Japanese letters are 表示可能"
  501. __try_exec diskinfo
  502. ! isdarwin && test -n "${DISPLAY}" && {
  503. __try_exec xrandr | \grep --color=never ^Screen
  504. }
  505. iswindows || __try_exec finger $USER
  506. LANG=C __try_exec id
  507. __try_exec xset q
  508. }
  509. x(){
  510. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  511. #mkdir -p ~/.my/log
  512. # nohup startx >~/.my/log/xorg.log 2>&1 &
  513. # exit
  514. exec startx
  515. else
  516. echo "X cant be started! Another X is already running?" 1>&2
  517. fi
  518. }
  519. bak(){
  520. for file in "$@"
  521. do
  522. cp -v ${file} ${file}.bak
  523. done
  524. }
  525. di(){
  526. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  527. then
  528. local diffcmd=colordiff
  529. else
  530. local diffcmd=diff
  531. fi
  532. ${diffcmd} -u "$@" | ${PAGER}
  533. }
  534. tb(){
  535. local tb="$HOME/.my/tb"
  536. mkdir -p "$tb"
  537. for file in "$@"
  538. do
  539. mv -t "$tb" "$file"
  540. done
  541. }
  542. mkcd(){
  543. if test -z "$1"
  544. then
  545. echo "mkcd: usage: mkcd <dir>"
  546. return 1
  547. elif test -d "$1"
  548. then
  549. echo "Dir \"$1\" already exists."
  550. else
  551. mkdir -p "$1"
  552. echo "Dir \"$1\" created."
  553. fi
  554. cd "$1"
  555. }
  556. mkcdd(){
  557. # make and change date directory
  558. _d=`date +%Y%m%d-%H%M%S`
  559. mkcd "$_d"
  560. }
  561. if test -n "$TMUX" && null type reattach-to-user-namespace
  562. then
  563. alias pbpaste="reattach-to-user-namespace pbpaste"
  564. alias pbcopy="reattach-to-user-namespace pbcopy"
  565. fi
  566. catclip(){
  567. if iswindows
  568. then
  569. cat /dev/clipboard | tr -d \\r
  570. elif isdarwin
  571. then
  572. pbpaste
  573. else
  574. xclip -o -selection "clipboard"
  575. fi
  576. }
  577. setclip(){
  578. if test $# -eq 0
  579. then
  580. exec 3<&0
  581. else
  582. exec 3<<__EOF__
  583. `cat "$@"`
  584. __EOF__
  585. fi
  586. if iswindows
  587. then
  588. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  589. elif isdarwin
  590. then
  591. pbcopy 0<&3
  592. else
  593. 0<&3 xclip -i -f -selection "primary" | \
  594. xclip -i -f -selection "clipboard"
  595. fi
  596. exec 3<&-
  597. }
  598. open_file(){
  599. if iswindows
  600. then
  601. cmd.exe //c start "" "$@"
  602. elif isdarwin
  603. then
  604. touch "$@"
  605. open "$@"
  606. elif islinux
  607. then
  608. touch "$@"
  609. if null type pcmanfm; then
  610. LC_MESSAGES= pcmanfm "$@"
  611. else
  612. LC_MESSAGES= xdg-open "$@" &
  613. fi
  614. else
  615. cat "$@"
  616. fi
  617. }
  618. o(){
  619. if test $# -eq 0
  620. then
  621. open_file .
  622. else
  623. for f in "$@"
  624. do
  625. open_file "$(realpath "$f")"
  626. done
  627. fi
  628. }
  629. convmv-sjis2utf8-test(){
  630. convmv -r -f sjis -t utf8 *
  631. }
  632. convmv-sjis2utf8-notest(){
  633. convmv -r -f sjis -t utf8 * --notest
  634. }
  635. winln(){
  636. # for windose make link (actually junction)
  637. if test $# -eq 0
  638. then
  639. {
  640. echo "usage: winln TARGET LINK_NAME"
  641. echo "Create a link to TARGET with the name LINK_NAME \
  642. (that is, TARGET must already exist)."
  643. echo "About other features run 'junction'."
  644. } 1>&2
  645. return 1
  646. else
  647. junction "$2" "$1"
  648. fi
  649. }
  650. #################################################
  651. ## pastebin services
  652. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  653. sprunge(){
  654. # http://sprunge.us
  655. if test -z "$1"
  656. then
  657. curl -F 'sprunge=<-' http://sprunge.us
  658. else
  659. curl http://sprunge.us/$1
  660. fi
  661. }
  662. dpaste(){
  663. # http://dpaste.de
  664. if test -z "$1"
  665. then
  666. curl -F 'content=<-' https://dpaste.de/api/
  667. echo
  668. else
  669. curl https://dpaste.de/$1/raw/
  670. fi
  671. }
  672. ######################################
  673. ## Prompt
  674. __my_moc_state(){
  675. type mocp >/dev/null 2>&1 || return
  676. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  677. printf "$1" "`mocp -Q %title 2>/dev/null`"
  678. }
  679. __my_parse_svn_branch() {
  680. local LANG=C
  681. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  682. local svn_repository_root=$(svn info 2>/dev/null | \
  683. sed -ne 's#^Repository Root: ##p')
  684. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  685. awk '{print $1}'
  686. }
  687. __my_svn_ps1(){
  688. if svn status >/dev/null 2>&1
  689. then
  690. local svn_branch=$(__my_parse_svn_branch)
  691. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  692. fi
  693. }
  694. __my_battery_status(){
  695. local dir=/sys/class/power_supply/BAT0
  696. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  697. test -r $dir/charge_now
  698. then
  699. local st=$(cat $dir/status)
  700. local full=$(cat $dir/charge_full)
  701. local now=$(cat $dir/charge_now)
  702. local rate=$(expr $now \* 100 / $full)
  703. printf "$1" "${st}:${rate}%"
  704. fi
  705. }
  706. alias bat='__my_battery_status %s\\n'
  707. ip-address(){
  708. type ip >/dev/null 2>&1 || return 1
  709. local ip=$(LANG=C ip addr show scope global | \
  710. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  711. test -n "$ip" && printf $1 $ip
  712. }
  713. test -n "$SCRIPT" && __my_ps1_script_str="${__my_c5}SCR${__my_cdef} "
  714. test -n "$SSH_CONNECTION" && __my_ps1_ssh_str="${__my_c5}SSH${__my_cdef} "
  715. __my_ps1_scale(){
  716. local last=$?
  717. printf "${LINES}x${COLUMNS}"
  718. return $last
  719. }
  720. __my_ps1_tmux(){
  721. local last=$?
  722. null type tmux || return $last
  723. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  724. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  725. return $last
  726. }
  727. __my_ps1_moc(){
  728. local last=$?
  729. __my_moc_state "[MOC:%s]"
  730. return $last
  731. }
  732. for f in /usr/share/git/git-prompt.sh \
  733. /opt/local/share/git-core/git-prompt.sh \
  734. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  735. do
  736. test -r $f && . $f && break
  737. done
  738. GIT_PS1_SHOWDIRTYSTATE=t
  739. GIT_PS1_SHOWUPSTREAM=t
  740. __my_ps1_git(){
  741. local last=$?
  742. null type __git_ps1 || return $last
  743. null __gitdir || return $last
  744. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  745. return $last
  746. }
  747. __my_ps1_ipaddr(){
  748. local last=$?
  749. ! iswindows && ip-address [Addr:%s]
  750. return $last
  751. }
  752. __my_ps1_bttry(){
  753. local last=$?
  754. local bst="${TMP}/batterystatus"
  755. if test -z "$DISPLAY" && ! iswindows
  756. then
  757. test -f $bst && local bstr="$(cat $bst)"
  758. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  759. echo "[Battery:$bstr]"
  760. __my_battery_status %s >$bst &
  761. fi
  762. return $last
  763. }
  764. __my_ps1_dirs(){
  765. dirs | wc -l
  766. }
  767. __my_ps1_jobs(){
  768. jobs | wc -l
  769. }
  770. if test "$TERM" != dumb
  771. then
  772. __my_c1="\[\e[0;33m\]" # color for PWD
  773. __my_c2="\[\e[0;36m\]" # color for user
  774. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  775. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  776. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;31m\]"
  777. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  778. else __my_c4="\[\e[1;32m\]" # color for ::
  779. fi
  780. __my_c5="\[\e[30;47m\]" # color for SCR
  781. __my_cdef="\[\e[0m\]"
  782. fi
  783. export _LAST_STATUS=$?
  784. __my_export_last_status(){
  785. export _LAST_STATUS=$?
  786. echo $_LAST_STATUS
  787. return $_LAST_STATUS
  788. }
  789. _ps1_bash="\
  790. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  791. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? $(__my_ps1_scale) \D{%T} ${__my_ps1_script_str}${__my_ps1_ssh_str}\$ "
  792. inbash && PS1=$_ps1_bash
  793. __my_set_screen_title(){
  794. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  795. then
  796. echo -ne "\033k$1\033\\"
  797. fi
  798. }
  799. __my_set_title(){
  800. case $TERM in
  801. (rxvt*|xterm*|aterm|screen*)
  802. title="$(echo $@)"
  803. test -t 1 &&
  804. test -n "$DISPLAY" &&
  805. test -z "$EMACS" &&
  806. echo -n -e "\033]0;${title}\007"
  807. ;;
  808. esac
  809. }
  810. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\:\${PWD};
  811. __my_set_screen_title \$(basename \"\$PWD\")/"